## 存储

我们最常用的，是 S3 对象存储。它价格便宜，而且使用灵活，支持在 s3 控制台直接查看数据内容、直接通过
CDN 提供给用户访问、配置生命周期策略等。不常用的数据还可以归档或者转为长期存储，更省钱。

第二类是 EBS 块存储，常用在 EC2 及 EKS 上：

1. SSD - 特点是随机读写很快，绝大部分场景都应该选择使用 SSD.
   1. gp3/gp2 - 普通 SSD，快，是最常用的 EBS 类型。
   2. io1 - 更快，更贵
2. HDD - 机械硬盘，随机 IO 慢但是顺序 IO 快，适合用于存储大文件，如视频、大数据存储等。

EBS 的缺点是：

- 必须要挂载到 EC2 实例上，才能看到里面的文件目录及内容
- 存储价格(SSD)是 S3 标准存储的三倍以上
- 扩缩容可能需要重启 EC2 实例，调整磁盘的文件系统设置

第三类是 EFS 文件存储，可按需动态扩容，支持 PB 级的存储，支持同时多人读写，支持 NFSv4.1 与 NFSv4.0
网络文件系统协议。EFS 性能比 S3 高很多，但是比 EBS 差，存储价格是 EBS 的三倍以上，S3 的十倍以上。它
的主要应用场景有：

- 支持支持同时多人读写，可以直接挂载到多个动态扩缩容的 lambda 函数、EKS 容器上。
- 分布式存储池，支持 PB 级的存储，可按需动态扩容（不影响程序运行），适合用于大数据存储分析等场景。
  - 不过好像 S3 用得更多，因为 S3 便宜啊

## Aurora 数据库

窟窿原理 - 三可用区，每个可用区两副本，同时写入 4 个实例，读取任意三个实例，保证性能和一致性。

比 MySQL 强，但是比 TiDB 差。

### RDS serverless

AutoScaling 太慢，改一个不太大的表要几个小时，线上不要用，也就 staging 可以用用。

## DynamoDB - DDB

文档数据库，类似 MongoDB.

我们每个业务线都有在用 DynamoDB，它读写分离、支持事务、可横向扩展，而且不需要我们维护，给钱就行。

DDB 甚至可以替代部分 RDS 利用好 DDB 的索引可以做关系映射有全局 / 本地 索引，官方提供 SQL 迁移到 DDB
的方案

所以我们基本上正在用 DynamoDB 替换我们的 MongoDB.
