# 计算机科学

## Roadmap

### 计算机网络 / Linux 网络

入门+进阶：

- 书：《计算机网络：自顶向下方法》
- 课
  程：[Stanford CS 144 - Introduction for Computer Network](https://www.bilibili.com/video/BV137411Z7LR)

高阶：

- TCP/IP Illustrated 2nd edition

实验：

- [miniTCP in Python](https://github.com/jvns/teeceepee/)

### Linux/操作系统

入门：

- [x] [《鸟哥的 Linux 私房菜》](https://linux.vbird.org): 学习使用 Linux 的基本概念和常用命令。
- [x] 《Linux C 编程一站式学习》：学习如何在 Linux 上编写、编译链接、调试 C 程序，make/gcc/gbd

进阶：

- 《CSAPP 深入理解计算机系统》: 操作系统、汇编、计算机结构等等
  - 资料：
    - [CSAPP-Labs](https://github.com/Exely/CSAPP-Labs)
  - 课程：
    - [Introduction to Computer Systems CMU 15-213 2015 Fall](https://www.bilibili.com/video/BV1Lx411p7Wn)
    - [Introduction to Computer Systems CMU 15-213 2017 Fall](https://www.bilibili.com/video/BV1gW411x7Bz)
- 《Linux/unix 系统编程手册》或《深入Linux内核架构》：学习 Linux/unix 系统的底层原理
- 《System Performance: Enterprise and the Cloud》- Linux 系统的性能分析

高阶：

- 课
  程：[MIT 6.828，动手补全一个 unixv6 系统的核心部分](https://pdos.csail.mit.edu/6.828/2020/xv6.html)
  - 资料：[xv6](https://github.com/MoSunDay/xv6)

### 分布式系统

- 书：《数据密集型应用系统设计》
- 课程：[MIT 6.824 - 分布式系统](https://pdos.csail.mit.edu/6.824/)
  - B 站视频：<https://www.bilibili.com/video/BV1R7411t71W>

### 数据库

如今的应用，核心就是数据库、缓存、消息队列等和数据有关的中间件。

这是一个相对年轻的研究领域，并且出于很强的商业动机，研究者把想法藏在紧闭的门后。此外，许多原本有潜力
写出优秀教材的作者反而选择了加入或创立公司。

鉴于如上情况，我们鼓励自学者大体上抛弃教材，而是从
[Berkeley CS 186 - Introduction to Database Systems 2021](https://www.bilibili.com/video/BV1B7411U7dZ)
这个课程开始，然后前往阅读论文。

进阶：

- 读论文: [“红书” - 数据库论文合集](http://www.redbook.io/)
- 实验
  - [tinysql](https://github.com/tidb-incubator/tinysql)
  - [tinykv](https://github.com/tidb-incubator/tinykv)

### 程序语言理论

PLT 就我个人而言，感觉不需要学到多深，大部分程序员最多也就能接触到一些 DSL、AST 而已。

而编译器的一些深度优化技术，是完全可以忽略的——这些知识我几乎用不上。

入门资料：

- https://craftinginterpreters.com/
- SICP 前三章
- The Little Scheme

进阶：

- 编程语言实现模式
- Essentials of Programming Languages
- SICP 后面的章节

## 参考

- [TeachYourselfCS-CN](https://github.com/keithnull/TeachYourselfCS-CN/blob/master/TeachYourselfCS-CN.md)
