# 四驱小车项目

所有配件

- 树莓派 4B 2G
- 面包板 + 面包板电源 + 母对母杜邦线 + 母对公杜邦线
- 移动电源 + USB 公对公数据线（面包板供电） + Type-C 供电线（树莓派供电）
- L9110S 四路直流电机驱动板 + 四驱小车底盘（带电机）

这一套去掉移动电源跟树莓派，总成本 40 元左右。

其他需要的东西：

- 为了组装小车，螺丝刀肯定是需要的
- 为了固定线路板、树莓派，需要一卷可重复使用的双面胶（或者用螺丝固定也行）
- 如果小车底盘的电机电源线未焊接，还需要使用电烙铁焊接下（也可直接铜丝缠上去，但是没有用电烙铁稳当）

我考虑后续把树莓派 4B 换成 ESP32 或 ESP8266 试试，树莓派的好处就是能直接 SSH 上去，使用标准 Linux 环
境写代码，非常方便简单，但是功耗大。单片机则是功耗低，但是环境简陋，代码编写与更新要麻烦许多，需要自
己写代码烧录进去。

## 相关概念

- DC: Direct Current，直流
- motor: 马达/电机
  - DC motor 直流电机，扭矩小，很容易失速（stall 熄火、暂停）
  - DC gear motor 直流齿轮电机，装有一个变速箱（gearbox）降低转速、提升扭矩
  - servo motor 伺服电机，即直流齿轮电机 + 传感器 + 反馈控制电路，能够较为精确地转动到某一个位置。
    - 被玩航模的人发明了一个新称谓：舵机
  - Stepper motor 步进电机，能够控制电机旋转特定的角度，是最精确的电机，通常会更笨重也更贵，运行相对
    慢很多，而且会产生大量热量。
    - 常用于需要精确移动的场景，如 3D 打印机。
  - Brushless motor 无刷电机，需要使用特殊控制器驱动。运行更安静、适合高速高扭矩场景，比如无人机旋
    翼。
- General Purpose Input Output (GPIO) 通用 I/O 引脚，可用于读取各种数字/模拟信号的输入，或者输出各种
  数字信号。
  - 树莓派或其他各种单片机，都是通过 GPIO 与其他通用硬件交互的。
- Pulse Width Modulation 脉宽调制（PWM）
  - GPIO 引脚只能输出数字信号，转换为电压即 3.3V 或者 0V。但是可以通过 PWM 来近似各种模拟信号的电压
    变化。PWN 通过控制脉冲电压的宽度与频率，在每一个很小的时段内模拟各种 0V 到 3.3V 之间的电压。

## 1. 树莓派 4 版本

代码参见此文件夹中的 `robot_car_pi.py`，详细介绍待补充。

### 供电相关的坑

1. 直接使用面包板电源给树莓派供电，发现 2.4 元一个的面包板电源电压没那么稳定...树莓派偶尔会有欠压告
   警，而且还老连不上 WiFi...
   1. 改用 Type-C 直接接移动电源给树莓派供电
2. 直接使用树莓派的 5V 引脚给面包板给电机驱动板供电，发现电机一运行树莓派的灯光亮度就变弱，看起来是
   顶不住。
   1. 改成直接使用移动电源单独给电机供电后问题解决。
3. 小车不运行时，移动电源会自动断电：我手上有好几个 Type-C 转接头，其中一个刚好可以避免这个问题，原
   理不太清楚（电压诱骗啥的？）。

## 参考

- 树莓派 4 引脚图：[Raspberry Pi 4 GPIO Pinout](https://linuxhint.com/gpio-pinout-raspberry-pi/)
- Xbox One 手柄的蓝牙驱动与连接方
  法：[Setting up Xbox Controllers on the Raspberry Pi](https://pimylifeup.com/xbox-controllers-raspberry-pi/)
- 使用 PyGame 获取 Xbox One 手柄事
  件：[How to use an Xbox Controller with your Robot](https://www.youtube.com/watch?v=F5Bq7HVJkX0)
