# 导热硅胶片与散热片

## 导热硅胶片

> 注：电脑常用的是导热硅脂，但是在嵌入式领域，芯片功率不高，发热没那么严重，用导热性能差一点的导热硅
> 胶就更方便便宜。

导热硅胶片是一种导热填充材料，能够填充缝隙，完成发热部位与散热部位间的热传递，同时还起到绝缘、减震、
密封等作用。

选择导热硅胶片要注意以下几点：

1. **越薄越好**：因为导热硅胶片作为一种热传递的介质，要想热传递效果更好，必须要降低导热硅胶片的热
   阻，而厚度越薄，导热硅胶片的热阻也将越低。此外越薄的导热硅胶片也更便宜。
   1. 在设计之初，就应该考虑导热硅胶片的厚度问题，要基本确认导热硅胶片的硬度及压缩量，以及压缩后对产
      品器件是否有应力产生， 产生的这个应力是否会对产品的电子元器件造成影响？一般建议尽量选择硬度
      低、应力小的导热硅胶片，也就是软性导热硅胶片，当然，也有些设计需要导热硅胶片起一定的支撑作用，
      这种情况就建议选择一些硬度比较大的导热硅胶片。
2. **导热系数**：原则上当然导热系数越高越好，但是还要考虑到硬度、面积、以及价格。
3. **粘性要求**: 原则上不推荐使用导热硅胶片背胶来代替其他固定装置，因为双面胶导热系数不高，使用背胶
   后的导热硅胶片整体导热效果会有所降低，双面背胶后效果更差。 另：导热硅胶片由于原材料的原因，会有微
   弱的自然粘性，但这并不能做固定用。
4. **出油率**: 市场上很多品牌的导热硅胶片都不同程度的含有一定量的硅油（低分子矽氧烷），而硅油有特别
   的活性，很容易在高温及长时间工作的时候挥发，而挥发的硅油会对产品造成污染，甚至会让有些敏感元器件
   霉变短路，所以出油率一般建议在 200PPM 以内

我买来主要给我的各种开发板用的，个人用不了多少所以贵点也没关系，整了俩 0.5mm 的深圳华越导热硅胶片，
一个普通的，一个 15W 高超导，先用着看看。

另外因为我买的散热片都是单独的元器件，不好固定，所以我普通的导热硅胶片选择的是双面背胶的，牺牲了一点
导热系数，但是可以方便的固定在散热片上。

## 散热片

### 1. 为什么散热片主要用铝合金

散热金属片基本都是铝制的，并没有使用导热管常用的铜。

导热管选用铜的原因显然是铜的导热性能更强，纯铜的导热系数为401 W/(m·K)，纯铝的导热系数为237 W/(m·K)，
铜的导热系数是铝的1.7倍。

但散热片还要考虑的另一个重要特性是比热容，铜的比热容为386KJ/kg·K，铝的比热容为900KJ/kg·K。铝的比热容
几乎是铜的三倍，所以一般选择铝散热片。

此外铝的价格也远低于铜（更便宜），密度也比铜低（更轻），这些因素导致了散热片主要使用铝金属。

### 2. 散热片结构设计

散热片的结构设计主要考虑的是散热片的厚度、形状、尺寸、材质、表面处理等。

1. 底部厚度：良好的底部厚度设计必须由热源部分厚而向边缘部份变薄，如此可使散热片由热源部份吸收足够的
   热向周围较薄的部份迅速传递。
2. 鳍片间隔：空气层的厚度约2mm，鳍片间格需在4mm以上才能确保自然对流顺利。但是却会造成鳍片数目减少而
   减少散热片面积。鳍片间格变狭窄会导致自然对流发生减低，降低散热效率。
3. 鳍片厚度与高度：鳍片变薄会造成鳍片传热到顶端能力变弱，鳍片变厚又会造成鳍片数目减少从而散热表面积
   减少，需要平衡这两项参数才能达到理想的效果。
4. 空气对流设计：
   1. 显然直接加个风扇顺着散热片的方向吹，效果最好。
   2. 对鳍片做横切将平板鳍片切成多个短的部分（额外开槽），这样虽然会减少散热表面积，但是却增加了空气
      对流，可以提升散热性能。

所以给开发板买无风扇散热片，在空间允许的情况下，应该尽量选择带剖槽、更高更厚的效果会更好些，我是各种
规格的都买了。
