## 嵌入式领域的一些现象

从 2022 年年底到现在，我接触嵌入式好几个月了。确实感觉到嵌入式领域的生态、学习/开发方法，都与软件存
在很大的区别。

首先是芯片方面的区别：

1. 底层的 mcu 性能差距不大，所以主要拼价格与生态，为了生态，stm32 跟 esp32 的开源都做得很
   好，datasheet、工具链全开源、文档齐全。
2. 而高端芯片如高通、联发科，市面上半点资料都没，想要个 sdk 跟文档还得花大价钱买，还得签保密协议，而
   且 sdk 跟文档内容也不咋地。是完全的 2B 思路。这也导致手机的第三方 ROM 制作难度高，因为从芯片到主
   板，大部分东西都是闭源的，即使受限于安卓的 GPL 证书开源了，对 Linux 系统的移植帮助也有限。
3. 夹在 mcu 与高端手机芯片之间的全志、瑞芯微则走了不太一样的路线。
   1. 全志也是高通一样的思路，半点文档都没，芯片根本没法玩。
   2. 瑞芯微相对而言稍微开放一点，有官方 github 仓库，但是里面存的是编译好的二进制包与 PDF 文档...所
      以说开放程度也有限。即使如此，rk 对开发者的友好程度也吊打全志了...
4. 目前芯片领域开源程度最高的，是新晋明星 RISC-V 指令集的玩家。
   1. 昉星光 2 搭载的惊鸿 7110 芯片的
      [datasheet](https://doc-en.rvspace.org/JH7110/Datasheet/JH7110_DS/introduction.html) 就写得比
      较清楚，开发者手册也写得还可以，不过芯片性能还弱了点、生态也还差比较远。
   2. 阿里的曳影 1520 芯片，四核玄铁 C910 以及 4TOPS@int8 AI 算力，SoC 的芯片与工具链在 2021 年就全
      开源了，而且性能比惊鸿强很多。文档得注册账号后才能看，但是感觉也写得很好。
   3. 以及 Sipeed 的 MaixPy 等开源项目，MaixHub 模型训练与分享平台，也都做得不错（开源情怀 + 性能不
      错，使我预购了两块 LicheePi4A）。

所以整个 ARM 高性能芯片行业，瑞芯微的文档、SDK 已经算是比较开放的了，即使它也是很多资料必须花钱买、
就算有些开源仓库也只存了 PDF + 二进制文件...

看来未来还是得看 RISC-V 啊，阿里平头哥、赛昉科技、Sipeed 等几家做 RISC-V 的新公司，开源方面都做得挺
好的。

### 关于 ARM GPU

ARM GPU 官方给的闭源驱动只有 OpenGL ES，可以说是只考虑了移动端的支持，Linux 下 Vulkan 都还没有支持。

这也导致全志、瑞芯微等芯片命令比较出名的 Soc，官方都仅提供 Android GPU 驱动，官方 Linux 系统甚至都没
预装 GPU 驱动，目前 Orange Pi 5 的 GPU 驱动还得装 armbian 系统并根据 armbian 社区的文档才能安装上...

## 嵌入式行业观察

- 行业利润率偏低
  - 嵌入式行业属于实业，重资产，实体行业成本比互联网虚拟经济高很多，分到嵌入式开发人员的蛋糕就小了
  - 利润最高的芯片长期被国外垄断，芯片厂商已经抽走大部分利润，还需要考虑存货，供应链，渠道，营销等成
    本
  - 互联网 APP 动不动千万用户量，而嵌入式产品很难达到这个量级，销量有限利润也就有限
- 生态割裂、封闭、资料少，而且越高端越封闭
  - 既没有广泛的技术分享的氛围，也没有良好的软硬件平台开发的生态环境，全都各自为战
  - 嵌入式开发是紧贴行业的，所以行业知识在其中占了非常大的部分，换个行业就不适用了。但是嵌入式的方向
    又实在太多，导致知识被淘汰的风险很大。就比如古早的 Windows Phone / 塞班系统，现在都已经被淘汰
    了。
- 国内大部分嵌入式的公司都是投机取巧，做着最低端的产品，技术含量低，公司利润也低，工资自然就低。
  - 就算技术含量稍微高一点，写写 bsp，做些复杂的 MCU 产品，本质上仍然是体力活，干个几年就到天花板了
    （这一条存疑）。
- 如果能更进一步搞搞 DSP FPGA 啥的，工资倒是能上去，但是一是这个门槛高没个研究生学历根本玩不来，二是
  FGPA 这种高度定制、极限性能的东西，注定了它的市场份额很小，就业机会有限。
- Linux 驱动是个比较大的方向，单纯会个别几种简单驱动的开发工资上不去，只是个螺丝钉。如果能够统筹全
  局，吃透大部分驱动的原理，对 Linux 内核有深入的了解，那么工资就能上去了。
  - 比如说对 GPU 驱动开发有深入了解，那就是个大佬了，工资肯定不低。

总的来说，对我而言目前确实，嵌入式更适合当成一个兴趣爱好，而不是一个职业。

或者说，什么时候考虑考个电子工程的研究生？？？等再过一两年，考个研究生正经学学电子工程，满足下自己的
兴趣，以后搞搞机器人、DSP、FPGA、Linux 驱动开发，业余整整 AI，感觉也不错啊，反正也不花家里钱，自己供
自己上大学，妥妥的。

## 为什么普通电脑都用共用同一个 OS 镜像，而 SBC 却要为每个型号单独定制一个 OS 镜像？

原因就是 x86_64 架构体系最初只有 Intel 一家公司做，即使是现在主要也就两家公司出货 CPU，很容易达成统
一，就算达不成统一也很容易让所有镜像同时兼容这两家公司的不同指令集（比如虚拟指令集，Intel 是
VT-x，AMD 是 AMD-v）。

但是虽然说兼容性很强，不同厂家、不同时段的 X86_64 芯片也是有区别的，所以我们也经常听别人说，将系统针
对特定芯片重新编译一次，可以达到更好的性能。

而 ARM 与 RISCV 架构就很碎片化了，ARM 主要是提供 IP 设计，SoC 都是各种下游厂商做的，SoC 的各种东西都
不一样，即使是同一厂商的芯片也会因为设计目标不同而出现明显区别（ARM 的应用场景比 x86 更苛刻，所以定
制化很明显），所以就需要定制化的 OS 镜像。

## 一块 Linux 开发板的设计开发全流程

超长神贴：https://jaycarlson.net/embedded-linux/#software
