# 扒谱

扒谱的目的：

- 遇到喜欢的歌想自己用乐器演奏/伴奏，或者用「人声合成软件」演唱
- 想用「编曲软件」、「人声合成软件」重新造个轮子
- 想学习下编曲的手法，或者单纯练下耳朵

这里主要介绍我们常听的流行音乐的扒谱方法。

## 扒谱的方法

最笨但是一定有效的办法，是借助「音高识别软件（如安卓上的 Tunner）」或者钢琴等乐器，一个个唱音/试音来
扒谱，一个个音地试，这样效率低、节奏啥的可能会差点，但是音高也能扒个像模像样。不过这样太低效了。

下面就介绍下一个标准的扒谱流程。不论你是直接听写谱子，还是通过编曲软件扒谱，大体都是下面这个流程：

1. 确定曲子的主音
2. 根据歌曲的强弱规律，确定节奏（拍子）
3. 跟着歌曲打拍子，确定bpm
4. 扒一段旋律，根据旋律的音阶、和弦，确定调式
5. 继续扒旋律：主旋律、各种乐器的旋律、和弦
6. 完成

下面分别介绍下上述流程中的几个步骤。

### 1. 确定曲子的主音

流行歌曲，旋律跟和弦，基本都是**结束在主音**。所以可以借助「音高识别软件（如安卓上的 Tunner）」确定
主旋律最后一个音的音高，或者最后一个和弦，来确定主音。

### 2. 确定节拍（节奏强弱）

根据音乐的节奏强弱，就能判定出节拍来。

技巧：

- 一是听重音，如果是单拍子(2/4、3/4)一个小节就只有一个重音点，复拍子。流行音乐的常见节拍：
  - 2/4 拍：「强 弱」，动次|动次
  - 4/4 拍：「强 弱 次强 弱」，动次打次|动次打次
  - 3/4 拍：「强 弱 弱」，一达达|二达达|三打打
  - 6/8 拍：「强 弱 弱 次强 弱 弱」，动次次打次次|动次次打次次
- 二是可以听和弦或者贝斯音的一个循环，一般来说每个小节走的都是相同的模式，只是和弦或者贝斯音不一样

### 3. 确定 bpm

- 方法一：使用「编曲软件」或者「节拍器」等软件，在每小节的强拍上点击「TAP」键，软件就能确定曲子的
  bpm.
- 方法二：使用「编曲软件」，通过波形图以及自己的听感，在音轨上选中某「一拍」，音轨上方就会显示选中的
  起止时间，「60s / 一拍的时值」，就能得到 bpm

通常来讲曲速会是 5 或者 10 个倍数，计算出结果后注意舍入下。

如果你是在使用「编曲软件」扒谱，那在确认了 bpm + 节拍后，下一步应该是要调整音轨，对齐歌曲的小节线。

通常来讲，绝大部分歌曲的时长本身就是很规整的，直接将波形图对齐到音轨的开头，节拍与 bpm 设置正确后，
乐曲就已经对齐了。

如果遇到意外情况需要手动对齐小节线，诀窍是按节拍来对齐小节线，所有「强」拍，都应该是一个小节的起始，
都需要对齐小节线。我们可以找到某一个强拍，将其波形图的开头对齐到某个小节线上，然后观察后续强拍的波形
图是否都差不多对齐。 **不需要强求所有节拍都完美对齐，一定的误差是可以接受的**，毕竟大部分歌曲都是人
演奏的，略有一点误差在所难免。

### 4. 确定曲子的调式

流行音乐基本不是大调跟就是小调。

- 根据主音的唱名可以确定曲子的调式。大调以 1 结束，小调以 6 结束，你试着找到很舒服的一种唱法，基本就
  能根据结束音的唱名确定调性。
- 根据曲风，和谐欢快的歌基本都是大调，小调通常会偏安静沉郁些（自然小调除外）。

### 6. 扒旋律

一支曲子的功能分层：

1. 节奏(Rhythm)：鼓
2. 低音(Bass)：贝斯
3. 织体(Texture)：音乐中各声部的组合方式(交织在一起，故称织体)。音乐在时间上的组合形式构成“曲式
   (music form)”，即音乐的进行。多声部在空间上的组合构成和声(Harmony)。和声织体——一条主旋律加上和声
   陪衬。通常用吉他、钢琴做陪衬。
4. 铺垫：
5. 点缀：

主旋律通常是最好扒的，可以直接使用编曲软件，利用上你的首调音感，在「钢琴卷帘」中把旋律一点点画出来，
然后跟原曲对比。

扒贝斯之类很难听清的旋律时，可以通过 加快曲速/升降调 来使它变清晰。万不得已不要加音量，对耳朵不好。

## 参考

- [口琴入门丨绅士菌来给大家说说扒谱那些事 - 知乎](https://zhuanlan.zhihu.com/p/55755643)
- [怎么扒bass谱？- 知乎](https://www.zhihu.com/question/22761077/answer/186513273)
- [怎么判断一首歌或者一首曲子是什么调性？- 知乎](https://www.zhihu.com/question/46533438)
- [如何听出一首歌的节拍? - 知乎](https://www.zhihu.com/question/27323509)
