## 一、安装代理客户端

目前 github 上最火的网络代理客户端（为了防止被和谐，下面的链接都是我的 fork 分支）

1. [Qv2-ray](https://github.com/ryan4yin/Qv2ray)：GUI 客户端，Linux/Windows/MacOS 都支持，同时支持
   v2ray/trojan/ssr 等多种协议。傻瓜式操作。
2. [clash](https://github.com/ryan4yin/clash): 一个后台客户端程序，支持 ssr/trojan 等多种协议。
   1. 官方提供一个 web dashboard: [clash-dashboard](https://github.com/Dreamacro/clash-dashboard)
   2. Android 和 Windows 都有对应的 GUI 封装包，傻瓜式操作。
3. [tun2socks](https://github.com/xjasonlyu/tun2socks/wiki): 一个全局透明代理，和 VPN 的工作模式一
   样，它通过创建虚拟网卡+修改路由表，在第三层网络层代理系统流量。

Qv2ray 默认支持 v2-ray 协议，通过安装插件，还可支持 tro-jan/s-sr 等流行协议。官方提供主流操作系统安
装包。

ArchLinux 安装命令(需要提前设置好 ArchLinuxCN 源)：

```shell
sudo pacman -S v2ray qv2ray qv2ray-plugin-trojan qv2ray-plugin-ssr-dev-git
```

Android 客户端貌似比较流行 [ClashForAndroid](https://github.com/Kr328/ClashForAndroid)，支持
tro-jan/s-sr 协议。

Windows 可以使用 Qv2ray，其他的流行客户端比如 ClashForWindows 已经被和谐了。。。

## 二、网络代理的几种类型

具体而言，在本机设置网络代理有三种设置方法

1. 「系统代理」：这是最常见的用法，前面介绍的 Qv2-ray 和 clash 默认都是使用这种方式提供代理。
   - 它的优点在于设置简便，而且性能好。缺点则是很多程序根本不理会「系统代理」，只有浏览器/steam 等少
     部分应用可以设置走系统代理。
1. 「应用代理」：通过环境变量 `http_proxy`/`https_proxy` 或者程序本身的设置，让应用直接走代理。
   - 前提也是程序本身支持这种配置。
1. 「第三层（网络层）代理」：通过设置 TUN（网络层）虚拟网卡，然后修改路由表将流量路由到 TUN 虚拟网
   卡。这种方式可以在网络层代理系统中的所有流量。
   - 所有的 VPN，都是通过这种手段实现的。
   - 前面提到过的 mellow，就是一个第三层代理，因此它是一个真正的全局代理。
   - 只有这种模式才支持代理 UDP 协议。

一劳永逸的方法，是在路由器上直接安装 clash 等代理软件，设置全局智能加速（利用 geoip）。这样网络内的
所有设备不论软件支持不支持，都能用上这个代理。

## 二、设置「应用代理」的几种方法

应用代理有很多的设置方法：

1. 如果应用本身支持配置网络代理，可以直接修改应用的配置或参数，让它走代理。
2. 设置 `http_proxy`/`https_proxy`，或者 `all_proxy` 这个三个环境变量。
   - 这几个环境变量对大多数命令行程序都有效，包括 apt/yum/git/curl/helm 等等
   - 对常见的 ss 等代理而言，上述三个环境变量的值都应该设为 `http://localhost:1080` 或者
     `socks5://localhost:1080`
3. 对于非 http/https 协议，可以使用 proxychains-ng 直接将 tcp 流量转发给 socks5/http 代理。

临时使用代理最简单的方法，就是方法二-设置环境变量：

```shell
export http_proxy=http://localhost:1080
export https_proxy=http://localhost:1080
export no_proxy=localhost,127.0.0.1,*.svc.local
```

默认情况下客户端代理工具只会提供 socks5 和 http 代理，因此上面的两个环境变量都应该配 `http` 协议或
者`socks5` 协议。

对非 http/https/ftp 的其他 tcp 流量，可使用方法一「应用本身的配置」或者方法三「proxychains-ng」。

### http_proxy/https_proxy 的大小写问题

http_proxy/https_proxy/ALL_PROXY/NO_PROXY 都只是一些约定俗成的环境变量，由各应用本身读取使用。它们不
是一个系统层面的环境变量（如 PATH），也没有唯一的标准。

各应用与环境变量 xxx_proxy 相关的文档：

- apt: [apt.conf](https://linux.die.net/man/5/apt.conf)
  - http_proxy/ftp_proxy
- curl: [Environment variables libcurl understands](https://curl.haxx.se/libcurl/c/libcurl-env.html)
  - http_proxy/https_proxy/ALL_PROXY/NO_PROXY
  - `http_proxy` 只接受小写！（Windows 因为大小写不敏感，所以大小写均可）
- git:
  [git-config - httpproxy](https://git-scm.com/docs/git-config#Documentation/git-config.txt-httpproxy)
  - http_proxy/https_proxy/all_proxy
- python:
  [urllib.request.getproxies - python](https://docs.python.org/3/library/urllib.request.html#urllib.request.getproxies)
  - HTTP_PROXY/HTTPS_PROXY，大小写均可。
- go: [net/http/httpproxy](https://golang.org/src/vendor/golang.org/x/net/http/httpproxy/proxy.go)
  - HTTP_PROXY/HTTPS_PROXY/NO_PROXY，大小写均可。
- docker:
  [Configure Docker to use a proxy server](https://docs.docker.com/network/proxy/#use-environment-variables)
  - docker 是用 go 写的，因此和 go 完全一致。

总的来说，对于 xxx_proxy 这个环境变量，因使用的软件/语言不同而不同。不过绝大部分应用都会兼容小写形
式。

## 参考

- [云计算底层技术-虚拟网络设备(tun/tap,veth)](https://opengers.github.io/openstack/openstack-base-virtual-network-devices-tuntap-veth/)
