# 物理层

网络物理层的传输媒介主要有：

1. 电信号：普通的纯铜网线，目前主流是六类非屏蔽千兆网线、USB 数据线。
   1. 链路层协议：基于双绞线的以太网物理层标准
2. 光信号：光纤，轻松支持万兆网（10GbE）
   1. 链路层协议：基于光纤的以太网物理层标准
3. 无线电：移动网络4G/5G, WiFi
   1. 链路层协议：4G/5G, 802.11 WiFI, Bluetooth 的物理层

「物理层」的标准定义了如何在物理媒介上传输来自数据链路层的数据，将逻辑数据转换成电信号/光信号/无线电
波，或者相反。

从上面的列表中能够看到，「物理层」的标准和链路层标准实际上是强耦合的，不同的「物理层」上的链路层协议
往往也有所区别，这将在下一章简单介绍。

## 一、以太网物理层 - [Ethernet_physical_layer - Wikipedia](https://en.wikipedia.org/wiki/Ethernet_physical_layer)

以太网是目前使用最广泛的局域网/广域网规范。

1. [百兆网(100BASE-TX)](https://en.wikipedia.org/wiki/Fast_Ethernet)：通常使用五类线。是正在被淘汰的
   标准。
2. [千兆网(1000BASE-T)](https://en.wikipedia.org/wiki/Gigabit_Ethernet): 通常使用超五类或者六类线。
   正在成为主流。
   1. 也被称为 1Gigabyte Network, 1GbE
3. [万兆网(10GBASE-T)](https://en.wikipedia.org/wiki/10_Gigabit_Ethernet): 目前是土豪和发烧友专用
   1. 万兆网未来会普及，但是可能主要介质会改用光纤和WiFi。因为同样速率下，电缆成本太高。

## 二、[网络线缆(networking cable)](https://en.wikipedia.org/wiki/Networking_cables)分类及传输速率

## 1. [以太网双绞线(Twisted pair)](https://en.wikipedia.org/wiki/Twisted_pair)

双绞线是目前局域网连接使用最广泛的线材，使用的连接端口是 RJ45。

双绞线有很多个标准，现在是 2020 年，布线推荐使用超五类(Cat 5e)或者六类(Cat 6)双绞线，这两类网线适
合[千兆以太网(GigaByte Ethernet)](https://en.wikipedia.org/wiki/Gigabit_Ethernet)。预算充足建议直接
用六类。

> 目前对于网络发烧友而言，六类线最高的 10GbE 可能已经满足不了他们的欲望了。这种情况下还是建议上更便
> 宜好用的光纤，或者退下烧...

| Name      | Typical construction      | Bandwidth   | Applications                                                   | Notes                                                                                                                                                                      |
| --------- | ------------------------- | ----------- | -------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Level 1   |                           | 0.4 MHz     | Telephone and modem lines                                      | Not described in EIA/TIA recommendations. Unsuitable for modern systems.[13]                                                                                               |
| Level 2   |                           | 4 MHz       | Older terminal systems, e.g. IBM 3270                          | Not described in EIA/TIA recommendations. Unsuitable for modern systems.[13]                                                                                               |
| Cat 3     | UTP[14]                   | 16 MHz[14]  | 10BASE-T / 100BASE-T4 [14]                                     | Described in EIA/TIA-568. Unsuitable for speeds above 16 Mbit/s. Now mainly for telephone cables[14]                                                                       |
| Cat 4     | UTP[14]                   | 20 MHz[14]  | 16 Mbit/s[14] Token Ring                                       | Not commonly used[14]                                                                                                                                                      |
| Cat 5     | UTP[14]                   | 100 MHz[14] | 100BASE-TX / 1000BASE-T [14]                                   | Common for current LANs. Superseded by Cat5e, but most Cat5 cables meet Cat5e standards.[14] Limited to 100m between equipment.                                            |
| Cat 5e    | UTP,[14] F/UTP, U/FTP[15] | 100 MHz[14] | 1000BASE-T / 2.5GBASE-T [14]                                   | Enhanced Cat5. Common for current LANs. Same construction as Cat5, but with better testing standards.[14] Limited to 100m between equipment.                               |
| Cat 6     | UTP,[14] F/UTP, U/FTP[16] | 250 MHz[14] | 5GBASE-T / 10GBASE-T                                           | ISO/IEC 11801 2nd Ed. (2002), ANSI/TIA 568-B.2-1. Most commonly installed cable in Finland according to the 2002 standard EN 50173-1. Limited to 55M distance at 10GBASE-T |
| Cat 6A    | UTP, F/UTP, U/FTP, S/FTP  | 500 MHz     | 5GBASE-T / 10GBASE-T                                           | Improved standards, tested to 500 MHz. Full 100M distance at 10GBASE-T ISO/IEC 11801 2nd Ed. Am. 2. (2008), ANSI/TIA-568-C.1 (2009)                                        |
| Cat 7     | S/FTP, F/FTP              | 600 MHz     | 5GBASE-T / 10GBASE-T or POTS/CATV/1000BASE-T over single cable | Fully shielded cable. ISO/IEC 11801 2nd Ed. (2002). It is not recognized by the EIA/TIA.                                                                                   |
| Cat 7A    | S/FTP, F/FTP              | 1000 MHz    | 5GBASE-T / 10GBASE-T or POTS/CATV/1000BASE-T over single cable | Uses all four pairs. ISO/IEC 11801 2nd Ed. Am. 2. (2008). It is not recognized by the EIA/TIA.                                                                             |
| Cat 8/8.1 | F/UTP, U/FTP              | 2000 MHz    | 25GBASE-T / 40GBASE-T                                          | ANSI/TIA-568-C.2-1, ISO/IEC 11801-1:2017                                                                                                                                   |
| Cat 8.2   | S/FTP, F/FTP              | 2000 MHz    | 25GBASE-T / 40GBASE-T                                          | ISO/IEC 11801-1:2017                                                                                                                                                       |

### 双绞线的线序

RJ45 双绞线制作水晶头时，主流的方法是网线两端都使用 EIA/TIA 568B 线序接线，这也被称为直通线。

以前同级设备相连（主机连主机，交换机连交换机的线），必须得使用交叉线——也就是一端用 EIA/TIA 568B 线
序，另一端使用 EIA/TIA 568A 线序。

不过现代路由器/交换机都可以自动识别线序，使用直通线进行同级连接时设备会自动识别到，并自动翻转信号。

因此 568A 和 568B 两种线序，或者交叉线序，都可以正常使用，设备会自动识别。

## 2. [光纤(Fiber optics)](https://en.wikipedia.org/wiki/Fiber-optic_cable)

千兆网以上，就是万兆网，组万兆网使用光纤 可能是更经济的选择。

随着互联网的高速发展，光纤的应用范围也越来越广，而双绞线则逐渐被光纤所取代。目前在中国办网络基本上都
是光纤到户。

使用光纤作为媒介的以太网标准大概有如下这些，目前的最高速率已经达到了 400GbE（仅摘录了部分）：

| Name                                                   | Standard (Clause)                                         | Common connectors                                                                                                                         | Description                                                                                                                                                                                                                                                                                                |
| ------------------------------------------------------ | --------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 1000BASE-SX                                            | 802.3z-1998 (38)                                          | ST, SC, LC                                                                                                                                | 8B10B NRZ coded signaling on 850 nm carrier, short-range multi-mode fiber (up to 550 m).                                                                                                                                                                                                                   |
| 1000BASE-BX10                                          | 802.3ah-2004 (59)                                         | SC, LC                                                                                                                                    | up to 10 km on 1490 and 1310 nm carriers; bidirectional over single strand of single-mode fiber; often called just 1000BASE-BX                                                                                                                                                                             |
| 1000BASE-LX10                                          | 802.3ah-2004 (59)                                         | SC, LC                                                                                                                                    | identical to 1000BASE-LX but increased power and sensitivity for up to 10 km over a pair of single-mode fiber; commonly called just 1000BASE-LX or, prior to 802.3ah, 1000BASE-LH; vendor-specific extensions exist for up to 40 km reach                                                                  |
| 10GBASE-SR                                             | 802.3ae-2002 (49&52)                                      | SC, LC                                                                                                                                    | Designed to support short distances over deployed multi-mode fiber cabling, it has a range of between 26 m and 400 m depending on cable type (modal bandwidth:reach: 160 MHz·km:26 m, 200 MHz·km:33 m, 400 MHz·km:66 m, 500 MHz·km:82 m, 2000 MHz·km:300 m, 4700 MHz·km:400 m)[16] using 850 nm wavelength |
| 10GBASE-LX4                                            | 802.3ae-2002 (48&53)                                      | SC, LC                                                                                                                                    | Uses four 8b/10b lanes with wavelength division multiplexing (1275, 1300, 1325, and 1350 nm) over deployed/legacy multi-mode cabling to support ranges of between 240 m and 300 m (400/500 MHz·km modal bandwidth). Also supports 10 km over single-mode fiber.                                            |
| 10GBASE-LR                                             | 802.3ae-2002 (49&52)                                      | SC, LC                                                                                                                                    | Supports 10 km over single-mode fiber using 1,310 nm wavelength                                                                                                                                                                                                                                            |
| 10GBASE-ER                                             | 802.3ae-2002 (49&52)                                      | SC, LC                                                                                                                                    | Supports 30 km over single-mode fiber using 1,550 nm wavelength (40 km over engineered links)                                                                                                                                                                                                              |
| 25GBASE-SR                                             | 802.3by-2016 (112)                                        | LC, SC                                                                                                                                    | 850 nm over multi-mode cabling with 100 m (OM4) or 70 m (OM3) reach                                                                                                                                                                                                                                        |
| 25GBASE-LR                                             | 802.3cc-2017 (114)                                        | LC, SC                                                                                                                                    | 1310 nm over single-mode cabling with 10 km reach                                                                                                                                                                                                                                                          |
| 25GBASE-ER                                             | 802.3cc-2017 (114)                                        | LC, SC                                                                                                                                    | 1550 nm over single-mode cabling with 30 km reach (40 km over engineered links)                                                                                                                                                                                                                            |
| 40GBASE-SR4                                            | 802.3ba-2010 (86)                                         | MPO                                                                                                                                       | At least 100 m over 2000 MHz·km multi-mode fiber (OM3) at least 150 m over 4700 MHz·km multi-mode fiber (OM4)                                                                                                                                                                                              |
| 40GBASE-LR4                                            | 802.3ba-2010 (87)                                         | SC, LC                                                                                                                                    | At least 10 km over single-mode fiber, CWDM with 4 lanes using 1270, 1290, 1310 and 1330 nm wavelength                                                                                                                                                                                                     |
| 40GBASE-ER4                                            | 802.3ba-2010 (87)                                         | SC, LC                                                                                                                                    | At least 30 km over single-mode fiber, CWDM with 4 lanes using 1270, 1290, 1310 and 1330 nm wavelength (40 km over engineered links)                                                                                                                                                                       |
| 40GBASE-FR                                             | 802.3bg-2011 (89)                                         | SC, LC                                                                                                                                    | Single lane, single-mode fiber over 2 km, 1550 nm wavelength                                                                                                                                                                                                                                               |
| 50GBASE-SR                                             | 802.3cd-2018 (138)                                        | LC, SC                                                                                                                                    | 100 m over OM4 multi-mode fiber using PAM-4, 70 m over OM3                                                                                                                                                                                                                                                 |
| 50GBASE-FR                                             | 802.3cd-2018 (139)                                        | LC, SC                                                                                                                                    | 2 km over single-mode fiber using PAM-4                                                                                                                                                                                                                                                                    |
| 50GBASE-LR                                             | 802.3cd-2018 (139)                                        | LC, SC                                                                                                                                    | 10 km over single-mode fiber using PAM-4                                                                                                                                                                                                                                                                   |
| 50GBASE-ER                                             | 802.3cd-2018 (139)                                        | LC, SC                                                                                                                                    | 30 km over single-mode fiber using PAM-4, 40 km over engineered links                                                                                                                                                                                                                                      |
| 100GBASE-SR10                                          | 802.3ba-2010 (86)                                         | MPO                                                                                                                                       | At least 100 m over 2000 MHz·km multi-mode fiber (OM3)                                                                                                                                                                                                                                                     |
| at least 150 m over 4700 MHz·km multi-mode fiber (OM4) |
| 100GBASE-SR4                                           | 802.3bm-2015 (95)                                         | MPO                                                                                                                                       | 4 lanes, at least 70 m over 2000 MHz·km multi-mode fiber (OM3)                                                                                                                                                                                                                                             |
| at least 100 m over 4700 MHz·km multi-mode fiber (OM4) |
| 100GBASE-SR2                                           | 802.3cd-2018 (138)                                        | MPO                                                                                                                                       | Two 50 Gbit/s lanes using PAM-4 over OM4 multi-mode fiber with 100 m reach, 70 m over OM3                                                                                                                                                                                                                  |
| 100GBASE-LR4                                           | 802.3ba-2010 (88)                                         | SC, LC                                                                                                                                    | At least 10 km over single-mode fiber, DWDM with 4 lanes using 1296, 1300, 1305 and 1310 nm wavelength                                                                                                                                                                                                     |
| 100GBASE-ER4                                           | 802.3ba-2010 (88)                                         | SC, LC                                                                                                                                    | At least 30 km over single-mode fiber, DWDM with 4 lanes using 1296, 1300, 1305 and 1310 nm wavelength (40 km over engineered links)                                                                                                                                                                       |
| 100GBASE-DR                                            | 802.3cu-2021 (140)                                        | LC, SC                                                                                                                                    | At least 500 m over single-mode fiber using a single lane                                                                                                                                                                                                                                                  |
| 100GBASE-FR                                            | At least 2 km over single-mode fiber using a single lane  |
| 100GBASE-LR                                            | At least 10 km over single-mode fiber using a single lane |
| 100GBASE-ZR                                            | 802.3ct (153 & 154)                                       | At least 80 km over single-mode fiber using a single wavelength over a DWDM system, also forming the base for 200GBASE-ZR and 400GBASE-ZR |
| 200GBASE-DR4                                           | 802.3bs-2017 (121)                                        | MPO                                                                                                                                       | Four PAM-4 lanes (26.5625 GBd) using individual strands of single-mode fiber with 500 m reach (1310 nm)                                                                                                                                                                                                    |
| 200GBASE-FR4                                           | 802.3bs-2017 (122)                                        | SC, LC                                                                                                                                    | Four PAM-4 lanes (26.5625 GBd) using four wavelengths (CWDM) over single-mode fiber with 2 km reach (1270/1290/1310/1330 nm)                                                                                                                                                                               |
| 200GBASE-LR4                                           | 802.3bs-2017 (122)                                        | SC, LC                                                                                                                                    | Four PAM-4 lanes (26.5625 GBd) using four wavelengths (DWDM, 1296/1300/1305/1309 nm) over single-mode fiber with 10 km reach                                                                                                                                                                               |
| 200GBASE-SR4                                           | 802.3cd-2018 (138)                                        | MPO                                                                                                                                       | Four PAM-4 lanes over OM4 multi-mode fiber with 100 m reach, 70 m over OM3                                                                                                                                                                                                                                 |
| 200GBASE-ER4                                           | 802.3cn-2019 (122)                                        |                                                                                                                                           | Four-lane using four wavelengths (DWDM, 1296/1300/1305/1309 nm) over single-mode fiber with 30 km reach, 40 km over engineered links                                                                                                                                                                       |
| 400GBASE-SR16                                          | 802.3bs-2017 (123)                                        | MPO                                                                                                                                       | Sixteen lanes (26.5625 Gbit/s) using individual strands of OM4/OM5 multi-mode fiber with 100 m reach or 70 m over OM3                                                                                                                                                                                      |
| 400GBASE-DR4                                           | 802.3bs-2017 (124)                                        | MPO                                                                                                                                       | Four PAM-4 lanes (53.125 GBd) using individual strands of single-mode fiber with 500 m reach (1310 nm)                                                                                                                                                                                                     |
| 400GBASE-FR8                                           | 802.3bs-2017 (122)                                        | SC, LC                                                                                                                                    | Eight PAM-4 lanes (26.5625 GBd) using eight wavelengths (CWDM) over single-mode fiber with 2 km reach                                                                                                                                                                                                      |
| 400GBASE-LR8                                           | 802.3bs-2017 (122)                                        | SC, LC                                                                                                                                    | Eight PAM-4 lanes (26.5625 GBd) using eight wavelengths (DWDM) over single-mode fiber with 10 km reach                                                                                                                                                                                                     |
| 400GBASE-FR4                                           | 802.3cu-2021                                              | SC, LC                                                                                                                                    | Four lanes/wavelengths (CWDM, 1271/1291/1311/1331 nm) over single-mode fiber with 2 km reach                                                                                                                                                                                                               |
| 400GBASE-LR4                                           | Four lanes over single-mode fiber with 10 km reach        |
| 400GBASE-SR8                                           | 802.3cm-2020 (138)                                        | SC, LC                                                                                                                                    | Eight-lane using individual strands of multi-mode fiber with 100 m reach                                                                                                                                                                                                                                   |
| 400GBASE-SR4.2                                         | 802.3cm-2020 (150)                                        | Four-lane using individual strands of multi-mode fiber with 100 m reach                                                                   |
| 400GBASE-ER8                                           | 802.3cn-2019 (122)                                        | SC, LC                                                                                                                                    | Eight-lane using eight wavelengths over single-mode fiber with 40 km reach                                                                                                                                                                                                                                 |
| 400GBASE-ZR                                            | 802.3ct (155 & 156)                                       | SC, LC                                                                                                                                    | At least 80 km over single-mode fiber using a single wavelength with 16QAM over a DWDM system                                                                                                                                                                                                              |

## 数据端口分类及传输速率

### 1. [Registered jack](https://en.wikipedia.org/wiki/Registered_jack)

即使用广泛的双绞线以太网网络端口：RJ45，感觉不需要多解释。

### 2. 光纤连接器与封装方式

传输速率越高，光纤的封装结构就越复杂，由此产生了多种光纤封装方式以及连接器类型。

常见的有：

- GBIC(<=1G>): 千兆以太网接口转换器。使用 SC 连接器，没错就是目前国内 99%+ 的入户光纤使用的连接器。
- SFP(<=4.25G)：小型可插拔光模块。使用 LC 光纤连接器，目前企业级路由器/交换级可能会自带此接口，比如
  ER-X SFP.
- SFP+(<=10G>)/SFP28(25G): 比 SFP 更强一些，也是目前的企业级路由器上可能会有的。
- QSFP+(40G): 四通道小型可热插拔光模块。QSFP+光模块一般使用 MPO 光纤连接器。
- ...

### 3. USB 端口

USB 作为一个万能接口，当然也可用于网络数据传输。。

USB 协议分类：

1. USB 2.0(2000), 480Mbps, 也就是说不考虑网络和协议损耗的情况下，速率能达到 60MB/s。
2. USB 3.2 Gen 1(2008), is **USB 3.0**. It has a maximum throughput of **5Gbps**. This is also known
   as SuperSpeed USB.
3. USB 3.2 Gen 2(2013), is **USB 3.1**. It has a maximum throughput of **10Gbps**. This is also
   known as SuperSpeed USB 10Gbps.
4. USB 3.2 Gen 2×2, is USB 3.2. It has a maximum throughput of **20Gbps**. This is also known as
   SuperSpeed USB 20Gbps.

USB 物理端口：

除了 PC 上广泛使用了 USB-A 端口，此外还有 USB-C 端口，也即 Type-C 端口(2015 年)。

另外还有一类曾经在手机等移动设备上广泛使用的端口：micro USB，也正在被 Type-C 替代。

## 参考

- [怎样区分百兆网线和千兆网线？](https://www.zhihu.com/question/20776809)
- [新家装修，布网线是七类线还是光纤？](https://www.zhihu.com/question/264177899/answer/1055820146)
- [光模块学习总结 - ](https://cshihong.github.io/2020/08/16/%E5%85%89%E6%A8%A1%E5%9D%97%E5%AD%A6%E4%B9%A0%E6%80%BB%E7%BB%93/)
