> 2018-01-26

目前传输层使用最广泛的只有两种协议：UDP 和 TCP

### UDP (User Data Protocol)

相当于对讲机，只约定好对某个频道发送信号，但是如果对方不回话。你就不知道对方到底收到了没。

1. 一次最多发送64k的数据。更大的需要分包发送。

2. 不建立连接，可能会丢包，不可靠。

3. 因为不需要建立连接，所以速度快。

4. 因此，接收方收到的数据包可能是缺失的，需要将数据包排序，列出未收到的包，然后再次请求这些丢失的数
   据。

### TCP(Transmission Control Protocol)：

类似打电话。会进行三次握手来建立连接。如果对方不接，或者对方挂了，连接会立马中断。（而断开连接需要四
次握手，另外断开连接时发起方可能进入TIME_WAIT状态长达数分钟。）

区别：

1. 基于连接与无连接；

2. 对系统资源的要求（TCP较多，UDP少）；

3. UDP程序结构较简单；

4. 流模式与数据报模式；

5. TCP保证数据正确性，UDP可能丢包，TCP保证数据顺序，UDP不保证。

### 应用场景：

1. TCP（有延时）：**When in doubt, use TCP. **
   1. TCP 是目前使用最广泛的传输层协议
2. UDP：a. 实时音视频流：- 因为这里重要的是实时，所以中间是否丢掉了一些数据（帧）是可以接受的。即使
   没丢了这些帧，也不需要重传（再次强调实时）。- 如果使用TCP，接收方现在有一秒的延迟，只要他不快进，
   那么视频就永远会延迟一秒。而且这种延迟还会累加。随着不断的丢帧，发送放需要不断补帧，延迟就会越来
   越大。。。b. 网络真的非常非常可靠，以至于你完全不需要考虑 UDP 丢包问题的情况。- 典型的例子应该是
   专门为有线局域网设计的协议。c. 另外一个问题是 TCP 是纯粹的流式数据，所以制定传输协议的时候，接受
   方需要自行判定一个包的开始和结束，因为你完全可能接受到半个包或者两个包。——如果数据报的起止判定对
   你具体的程序会成为大问题，也可以考虑 UDP。d. 翻墙：udp更容易穿越防火墙。e. **HTTP/3** QUIC 是基于
   UDP 的，未来 UDP 的应用很可能更广泛。

带宽抢占：

1. udp：发送流量全凭用户掌控
1. tcp：tcp连接间公平共享带宽，所以应用若使用多条并行tcp，就可抢到更多带宽

**NOTE1**：因为 udp 的速率太随意，可能导致网络严重拥塞，所以有时候会被路由器直接 drop 掉。这种情况下
udp 也变得不可靠了。

**NOTE2**：但是这个局面未来很可能发生变化，因为 TCP 的一些缺陷，目前 HTTP/3 协议已经基于 UDP 了。
