# 高负载下网关层常见问题

1. 4 层网关需要充分考虑内核参数调优，否则 nf_conntrack/tcp 连接数等参数都会成为瓶颈。
   1. tcp/ip 底层丢包，通常会导致 504
2. 业务侧上新功能时未充分考虑网关层或服务自身的处理能力，比如定时整点上报数据之类的功能，导致流量在
   某些时间点暴涨，网关或服务因为负载过高而崩溃。
3. nginx upstream 的 DNS 地址被删除解析，这会导致新启动的 nginx 进程因为配置异常而无法启动！
   1. 解决方法是跑个 CI 定时 check nginx 配置是否正常。
4. 未限制 API 并发数，导致部分 API 占用了大量网关资源，网关层负载高涨。
5. 未设置连接池，导致每次请求都会创建新的连接，导致网关层负载高涨、甚至端口耗尽（每个 tcp 连接断开后
   都需要 2msl 的时间才能被重用）。
6. 重试机制使用不当导致的流量放大，引发雪崩。
7. 出问题时没有完善的监控，需要手动使用各种命令去排查问题，导致排查效率低下。
   1. 解决方法：通过 node_exporter 导出网关的重要指标，通过 grafana 展示，通过 alertmanager 发送告
      警。
   2. 比如 TCP 连接数、nf_conntrack 计数、CPU 使用率、内存使用率、磁盘使用率、磁盘 IO 等。
8. 使用 AWS NLB 四层负载均衡时，遇到过它 targetgroup 更新太慢，导致 k8s pod 被删除后，出现大量 504
   错误。
   1. 解决方法：NLB 的硬件就这样，没办法，只能给 pod 加个 360s 的删除延迟，等 NLB 更新完毕后再删除
      pod，避免 504。
9. `X-Forwarded-For` 等 X- 开头的 header 设置不当，导致后端服务无法获取真实的客户端 IP。
   1. 这个问题也常见于 CDN 等各种中间代理。
