# Go 性能分析

- go test 提供三种测试能力：
  - `testing.T`: 对应的函数名需以 `Test` 为前缀，普通的单元测试、集成测试都用它
    - 可通过 `go test -cover -covermode=count` 计算测试的语句覆盖度
  - `testing.B`: 对应的函数名需以 `Bench` 为前缀，专门用于进行性能测试
    - `go test -bench=. -benchmem` 性能测试的同时记录内存分配次数，通常内存分配越频繁性能就越差
  - 样例: 对应的函数名需以 `Example` 为前缀，用于进行包的使用演示
- 性能剖析 Profiling
  - go 提供三种性能剖析的模式：
    - CPU Profiling: `go test -cpuprofile=cpu.out`
    - Memory Profiling: `go test -memprofile=cpu.out`
    - Blocking Profiling: `go test -blokeprofile=cpu.out`
  - 测试完成后使用 pprof 进行分析
    - `go tool pprof -text -nodecount=10 ./http.test cpu.out`
