值类型变量存储在栈上，引用类型变量存储在堆中。

**Go 的基础类型中，只有五种引用类型：切片(slice)、字典(map)、管道(channel)、指针（pointer）、函数
（function）**，其他的都是值类型（如数组、结构体）。

另外方法（method）可看作是一类特殊的函数，因此也是引用类型。

值类型变量作为参数传递时，传递的是值的拷贝，因此修改它的值对外部是没影响的。引用类型变量作为参数传递
时，传递的是引用的拷贝，修改它会影响到底层的数据。

## make：为引用类型进行空间预分配

值类型变量在声明时被初始化，而引用类型的变量（slice/map/channel）必须手动通过 new/make 给它预先分配
空间。

`new` 为某个类型分配空间，并返回其指针，但是实际用得很少。因为定义一个类型通常就自动分配空间了，而引
用类型通常使用 `make` 分配空间，好处是 make 可以指定 slice/channel 的 capacity.
