> 个人笔记

Python 的测试工具，常用的就两个：pytest 和 unittest。

unittest 是已经被收入了标准库的，它脱胎于 Java 的 Junit 框架，因此使用上也非常相似。如果有学过
Junit，会感觉 unittest 很亲切。

而 pytest 则是专门为 Python 设计的，它比 unittest 更简单易用，更灵活，而且 pytest 也支持直接运行
unittest 代码。此外 pytest 还拥有一个插件系统，提供丰富的各种插件：

1. pytest-selenium: selenium 自动化测试
1. pytest-html: 测试结果 html 渲染
1. pytest-cov: 计算测试覆盖率
1. pytest-mock: 对 unittest mock 的封装
1. pytest-asyncio: 支持测试异步代码

更多插件参见 Github pytest-dev 仓库，pytest 是 Python 社区最受欢迎的测试框架。

## java 的 junit 对比 python 的 unittest

| 方法             | java         | python        |
| ---------------- | ------------ | ------------- |
| TestCase类创建前 | @BeforeClass | setUpClass    |
| TestCase类销毁后 | @AfterClass  | tearDownClass |
| 方法运行前       | @Before      | setUp         |
| 方法运行后       | @After       | tearDown      |
| 测试方法         | @Test        | test_xxx      |
| 断言             | assert.xxx   | asertxxx      |

### 参考

- [pytest docs](https://docs.pytest.org/en/latest/)
- [Pycharm Help - Pytest](https://www.jetbrains.com/help/pycharm/pytest.html)

- [python docs - unittest](https://docs.python.org/3/library/unittest.html)
- [Java 单元测试 - Junit](https://www.cnblogs.com/kirito-c/p/9203785.html)
