# Web Assembly

WASM 是一项通用的虚拟机/安全沙箱技术，Go/Rust/C 等多种语言都能被编译为 WASM 字节码。

WASM 最初的设计目标是在浏览器中处理一些需要高性能的任务，比如 3D 图像处理。但是随着发展，它的通用性
正被越来越多的人看到。

Envoy 使用 WASM 来构建自己的插件系统，取代掉传统的 Lua 等嵌入式运行时，因 WASM 具有更强的通用型，能
支持各种通用编程语言。

另一方面 Docker 的创始人认为，如果 2008 年就出现了 WASM 和 WASI(WebAssembly System Interface)，那他
根本没有必要创造 Docker. 言下之意，WASM+WASI 是一项非常有潜力的容器技术。

容器说到底也就是一个可以随处运行的、不依赖宿主机环境的程序。如果 WASM 作为一项虚拟机技术，也能做到和
Docker 同样的资源隔离、安全限制，那它确实是可以和 Docker 拼一拼。

只是区别在于 WASM 更底层，它的特性决定了它只支持静态语言。而 Docker 则更通用，因为它是基于 OS 的，任
何语言编写的程序都可以打包成 Docker 镜像，在任何受支持的 Linux 操作系统上运行。
