# ADHD 注意力缺陷过动障碍

我于 2023/10/15 确诊 ADHD，这里记录下相关资料。

我最早的公开记录
是：[从 ADHD 注意力缺失症聊开去](https://0xffff.one/d/1643-cong-adhd-zhu-yi-li-que-shi-zheng/)

## ADHD 患者如何自我管理

1. 遵照医嘱，通过药物治疗，提高自己的注意力水平
1. 通过拼图、正念、冥想等方式，训练提高自己的专注力
1. 使用各种结构来约束自己的行为
   1. 番茄工作法
   2. Todo List - 代办事项清单（Kanban）
   3. 按 OKR 等方式来管理自己的目标
   4. 重要的事提醒三遍
1. 使用各种 APP 来帮助自己应用上各种结构
   1. 番茄工作法
      1. **Forest 专注森林**: 它的好处是比普通的番茄钟要有意思很多，甚至能种植真树，也就让人更容易坚
         持。
   2. Todo List
      1. 市面上挺多这种软件，选个自己喜欢的就好。如果是家庭还可以搞个团队协作版（基本各种企业也都有
         用类似的管理软件，比如 trello / jira / google calender）。
      1. 也可以考虑直接用笔记 APP 或者漂亮的纸制手账来记录。
1. 通过音乐提高专注力
   1. 收藏些自然音乐、白噪音的歌单
   2. **动态生成的音乐 - Endel**
      1. 这款软件受到大量推荐，它动态生成的音乐总有变化，而且运动模式下还可以根据运动状态同步调整音
         乐节奏。
      1. 而且其官方表示，科学研究证实了其音乐的有效
         性：[The science behind Focus](https://endel.io/blog/the-science-behind-focus)
1. 知识管理
   1. 有人喜欢用 Emacs 管理一切，有人喜欢 Obsidian/Logseq/Notion 等知识管理软件，有人喜欢用纸质笔记
      本，尝试后选择自己喜欢的就好。
   1. 我现在的公开知识库是 Git 仓库 + Vim 这样的组合，未来可能会尝试下 Obsidian/Logseq. 而私有笔记从
      15 年开始一直用的「印象笔记 APP」，一直没换。

> 注：以上这些软件多多少少都有些相互重叠的功能，比如 forest 也有白噪声、Todo List APP 可能也有番茄钟
> 功能、后面的 Endel 也提供了番茄钟功能。视自己需要使用吧。

## 我读过的相关资料

- 《分心不是我的错》
- [The ADHD Statistics You Need To Know](https://www.theminiadhdcoach.com/adhd-awareness/adhd-statistics)
- [中国成人注意缺陷多动障碍诊断和治疗专家共识（2023版](https://rs.yiigle.com/cmaid/1467089#T1)
