# 心理学

> 我的心理学学习方法：参照豆瓣书籍评分，一次性买了一批心理学的书籍，然后按喜好跟书籍评价排序，一口气
> 看完。这种学习方法能让我对整个心理学有一个整体性的了解，比如说我看的《被讨厌的勇气》显然就跟现代心
> 理学的见解很不同。研究这些异同也是加深理解的重要学习手段。只从一两个信息来源去学习心理学，容易形成
> 片面的认识。

哲学是科学之母，导致了自然科学产生的那些基本观念，其实是哲学原理的演绎结果。

同理，早期的心理学也是属于哲学的范畴，称为哲学心理学。而现代心理学则主要是基于实证主义的科学心理学，
科学心理学效仿自然科学，崇尚实验。

## 心理学的历史

心理学作为一门科学只有很短的历史，但却有一个漫长的过去。心理学可以追溯到古代的哲学思想，哲学和宗教很
早就讨论了身和心的关系以及人的认识是怎样产生的问题。古希腊哲学家柏拉图、亚里士多德等，中国古代思想家
老子、孔子、荀子、王充等都有不少关于心灵的论述。

国际心理学界公认现代心理学是在1879年建立的。这一年，W.冯特在莱比锡大学建立了世界上第一个心理学实验
室，心理学从此宣告脱离哲学而成为独立的科学。冯特的心理学实验室主要研究感知觉心理过程，所用的主要是生
理学的实验技术，所以他称自己的这种研究为生理心理学，又称实验心理学。从此，现代心理学经历了约140年的
历史。在这期间，关于心理学研究对象的讨论有过几次大的反复。最初，冯特认为心理学是研究人的直接经验或意
识的科学，复杂的心理活动是由简单的单元构成的。心理学的任务就是把心理活动分解为一些心理元素。例如，对
一本书的知觉是由长方的形状、一定的大小、绿色的书皮等感觉成分相加而成的。这种看法无疑受到当时化学发展
的影响。化学采取了分析的方法，化学元素才不断被发现。正因如此，后人才把冯特的心理学体系称作元素心理学
或构造心理学。

但即使科学心理学如今大行其道，心理学的哲学与人文性质也从未消失（这不像物理化学等自然科学，它们现在都
不再包含任何人文因素）。这是因为科学心理学基于实证主义，强调实验方法，但人类的社会、文化等环境因素太
过复杂，无法简单地操控与量化，无法用实验方法来研究。这导致科学心理学直接选择避而不谈这部分心理学内
容。因此科学心理学也被一些临床心理学家批评其「过于片面、脱离实际，忽略了人的精神需求，不能真正解决病
人的问题。」

历史上曾经流行过，但现在（至少在学术界）已经被边缘化的心理学派大概这些：

- 精神分析学
  - 代表人物：弗洛伊德、荣格
  - 评价：弗洛伊德是心理学的先驱，其精神分析理论据说相当复杂。其理论因为没有科学依据，与科学哲学相
    悖，目前已经不被主流的现代心理学所接受，甚至被诸多科学界人士批判为「**伪科学**」、「**巫医**」。
  - 补充：弗洛伊德提出的潜意识、自我本我超我、梦的解析、俄狄浦斯情结（恋母情结）等概念虽然已经不被现
    代心理学所接受，但因其足够新颖足够吸引眼球，其在文学、电影等人文艺术领域仍然有很大的影响，也最为
    大众所熟知。
  - 相关畅销书籍：
    - 《梦的解析》
    - 《性学三论》
    - 等等
- 个体心理学（人本主义的先驱）
  - 代表人物：阿德勒
  - 评价：阿德勒是精神分析学早期的核心人物，后来因发展其个体心理学理论而与弗洛伊德决裂。其个体心理学
    理论相比科学，它更偏向哲学。
  - 补充：阿德勒付出了巨大的努力以推动其理念进入普通家庭和学校，他的理论对于现代心理学、现代教育、家
    庭教育等领域都产生了很大的影响。阿德勒心理学因其浅显易懂、而且相当乐观，当前在大众领域也颇受欢
    迎。（另一方面，个体心理学可能真的只是阿德勒一个人的心理学，因为在他逝世后已无后人能够代表阿德勒
    发展阿德勒的个体心理学，因此显然在现代心理学界它也没什么地位。）
  - 相关畅销书籍：
    - 《被讨厌的勇气》
    - 《孩子：挑战（Children - The Challenge）》
    - 等等
- 人本主义
  - 代表人物：马斯洛
  - 评价：需求层次论是马斯洛的代表作，其理论得到广泛研究，在大众领域也有较大影响。但该理论也有不少争
    议。
- 行为主义
- ...

## 现代心理学的分支

现代心理学的主流是科学心理学，科学心理学的下属分支相当的多，主要的分支如下：

- 生物心理学
  - 从生理的角度研究各种心理现象。比如巴甫洛夫的条件反射实验，就是从生理的角度研究了动物的学习过程。
  - 主要使用动物做实验，有时也会结合医疗实践进行临床研究。
- 认知心理学
  - 20 世纪 60 年代兴起的研究方向。研究人类的认知过程，尤其是记忆、思维与问题解决。
  - 认知心理学受现代科学中的信息论与控制论的影响很大。
- 发展心理学
  - 研究人类发展过程中的心理特点与规律，包括婴儿、儿童、青少年、成人等各个阶段。
  - 比如儿童的语言学习能力是最强的、青春期的青少年会表现出明显的心理与行为的改变，等等。
- 社会心理学
  - 研究个体与群体在社会相互作用中的心理过程与行为的发生与变化规律。
- 人格心理学
  - 注重从整体视角研究人性本质。
- 理论心理学与心理学体系的研究
  - 从哲学的高度的探讨心理学的方法论问题。

此外，心理学在应用领域也存在许多分支：

- 教育心理学
- 医学心理学
- ...

## 参考

- [现代自然科学发端于近代哲学](http://www.nopss.gov.cn/GB/219470/17955832.html)
- [心理学 - 中国大百科全书 第三版网络版](https://www.zgbk.com/ecph/words?SiteID=1&Name=%E5%BF%83%E7%90%86%E5%AD%A6#section1-1)
- [心理学 - 维基百科](https://zh.wikipedia.org/wiki/%E5%BF%83%E7%90%86%E5%AD%A6)
- [阿德勒和荣格在现代心理学的地位如何？ - 知乎](https://www.zhihu.com/question/420361783)
