# 科学心理学

## 《这才是心理学》读书笔记

心理学与科学：

1. 任何人想要理解心理学，第一步也是至关重要的一步，就是要认识到心理学的首要特征——它是基于数据的科学
   的行为研究。
1. 历史上有许多最初公众抗拒使用科学，而接受用哲学思辨、神学谕告或世俗智慧来解释自然界的例子。每一门
   科学都经历了一个抵制其发展的阶段。
   1. 我：比如说伽利略的望远镜、哥白尼的日心说、达尔文的进化论、解剖学、人类学等等。
1. 关于人类的知识向前买进的每一步都引发了对抗。然而，当人们认识到科学并没有损害我们生命的意义，反而
   使它更丰富时，对抗终将烟消云散。
   1. 我：也就是说，科学心理学现在遭遇的这些抵制，正说明它走在正确的道路上，没什么好奇怪的。
1. 科学的三个重要且相互关联的特征：
   1. 使用系统的实证主义（empiricism）方法。科学家通过检验来认识世界。根据观察结果，一些理论得到支
      持，而另一些则被拒绝。
   1. 以获取可公开验证的知识为目标。手段主要是可重复性和同行评审。可重复性保证了科学家的发现不是偶然
      的，而是可以被其他人复制的。同行评审保证了被发表的科学发现具有一定可信度。
   1. 寻求可实证解决的问题，进而发展出可检验的理论。因此科学家不研究「人性本善还是本恶？」「生命的意
      义是什么？」这样不可检验的问题。

可证伪性：

1. 三个世纪以来，实证方法显示出了强大的力量。但实证方法不一定显而易见，这就是为何即使在一个科学占主
   导地位的社会中，我们也不得不经常讲授实证方法的原因。
1. 可检验性标准通常被称为可证伪性标准。任何科学理论都必须是可证伪的，也就是说它们要担负一些被证明是
   错误的风险。这就是科学得以发展以及新的科学得以产生的方式。
1. 问题本质上并无可解决（能产生可检验的理论）与不可解决（只能产生不可检验的理论）之分，当前不可解决
   的问题，在理论与实证方法或技术更加先进的时候，可能会变得可解决。比如 DNA 技术的发展就使得亲子鉴定
   成为一个可解决的问题。
1. 心理学所研究的问题最初都属于哲学的领域，譬如说「一个孩子如何获得其父母的语言？」「为什么我们会忘
   记我们曾经知道的事情？」「深处一个群体中会如何改变一个人的行为与思想？」等等。随着人类对这些问题
   认识的深入，心理学逐渐从其他领域中独立出来，汇聚成了一门独立的实证科学。
1. 世俗智慧或者说民间谚语，世俗智慧对天底下发生的所有事情都能做出解释。但它往往不可被证伪，而且常常
   互相矛盾。
   1. 譬如「三思而后行」与「机不可失，失不再来」，「欲速则不达」与「时不我待」，「三个臭皮匠，赛过诸
      葛亮」与「人多误事」，「今日事今日毕」与「顺其自然」。
1. 这些世俗智慧都是「事后诸葛亮」，「一切都显而易见——一旦你知道答案」。在真正的预测意义上这些世俗智
   慧都是无用的。
   1. 我：「事后诸葛亮」也就是原因论，从当前的结果往回反推其原因。这种方法只能用于自欺欺人，无法被用
      于预测未来。
1. 心理学研究表明，许多常见的关于行为的文化信念（即被认为「显而易见」的常识）在接受实证检验后，都被
   证明是错误的。
1. 心理学这种世俗智慧实证检验者的角色，常常使其与很多根深蒂固的文化信念发生冲突。历史上的科学都是因
   为类似的原因而遭到抵制的。
1. 好的理论会作出精确严密的预测，让自己很有可能被证伪，预测越精确严密，那实证的说服力就越强。坏的理
   论则不会以这种方式把自己置于危险之中，他们总能在任何场景下自圆其说。当一种理论过度保护自我以免于
   被证伪时，它就不再被认为是科学。
   1. 坏的理论有如：弗洛伊德的精神分析学说，本杰明的放血疗法，等等。好的理论譬如牛顿的万有引力定律，
      它的预测相当的精确，如果它是错误的，很容易通过实验来证伪。
1. 这些不可证伪的理论（伪科学）巨大的心理吸引力在于，它们可以解释一切。预先知道无论发生什么事情，都
   可以用这些理论来解释。它不仅给人一种掌握知识的感觉，更重要的是，它给人以应对这个世界所需的情绪上
   的安全感。但安全、不可证伪就意味着理论无法得到发展，获得这种安全感是以知识发展的停滞为代价的。科
   学追求的是知识的发展，不追求这种安全感。
1. 科学鼓励证伪，鼓励交叉验证，在科学上犯错不是罪过。科学的本质就是「在公众面前犯错，在众目睽睽下犯
   错，从而使错误得意被修正。」通过对理论的不断修正，科学家们才能共同构建起能更好地反应世界本质的理
   论。
1. 科学的支柱之一是失败，失败是成功之母。
1. 一个假设被确信为真的程度，与该假设是否为真无关。
1. 不可证伪的理论在科学上没有任何价值，无论它们多么让人感到安心、欣慰。

操作主义与本质主义：

1. 本质主义要求对现象的内在本质或本质属性做出终极解释。本质主义者喜欢咬文嚼字，譬如「地心引力这个术
   语的**真正**含义是什么？当说到地心引力时，我们到底在说什么？」
1. 科学家是操作主义者，科学不回答这种本质主义的问题，本质主义会让我们陷入无休止的文字游戏中。科学是
   对概念进行操作性定义得意进步的。
   1. 如果非要回答，那科学家的回答会是「地心引力/生命一词没有什么真正的含义，它只是一种用法，是为了
      很好地满足科学工作的需要而选择的词汇。」
1. 操作主义的思想：科学理论的概念必须以某种方式建立在可观察事件的基础之上，或与之相关联，而这些可观
   察事件是可以被测量的。
1. 寻求某概念的一个好的操作性定义会迫使你认真地、实证地思考一个概念的方方面面。
1. 科学概念的操作性定义是不断演进的，并非一成不变。此外同一科学概念也可能存在多种不同的操作性定义。
   比如「失业率」就有许多种不同的计算方法，「行星」一词在学界也存在两种不同的操作性定义。
