# 阿勒德心理学

> 阿勒德心理学并非现代心理学的主流分支，其学说当下的研究者寥寥。但其学说相当正面、乐观，因此在大众领
> 域较受欢迎。比如说的我入坑作《被讨厌的勇气》。

## 《被讨厌的勇气》读书笔记

1. 哲人的主张：**世界简单地令人难以置信，人生也是一样。人们随时可以获得幸福**
2. 在怎么找原因，也改变不了一个人。把当前的人生归咎于无法改变的过去，是一种逃避责任的行为，会导致人
   永远止步不前。
3. 决定我们人生的，不是过去，而是我自身赋予过去这些经历的意义。阿勒德心理学明确否认「心灵创伤」。
   1. 我：这里我得说心灵创伤真的还挺难治愈的，因为一些不好的经历而罹患抑郁症甚至轻生的人不在少数。这
      么简单的说它不存在，我无法接受。
4. 你想通过大发雷霆来震慑犯错的服务员，作为相应的手段，你便捏造了愤怒这种感情。这就是目的论对「你受
   怒气支配而大发雷霆」的解释。
   1. 我：这个目的论太反直觉了，我觉得这种解释不靠谱。
5. 重要的不是被给予了什么，而是如何去利用被给予的东西（可以改变的当下）。
   1. 我：这我还挺认同的，我们无法改变「过去被给予了什么」，关注这一点没任何作用，但「如何利用被给予
      的东西」是我们可以改变的。
6. 现在的你之所以不幸是因为你亲手选择了不幸。
   1. 我：确实有些道理，如果一个人能立即放下所有过去的经历，那 TA 确实能立即获得幸福。可当下的 TA 就
      是构建在过去的经历上的，「立即放下所有的过去」就等于重建自己心灵的基石，这几乎是不可能的。
7. 假若生活方式不是先天被给予的，而是自己选择的结果，那么就可以由自己进行重新选择。人们之所以想要改
   变但却未能改变，是因为他们缺乏「获得幸福的勇气」。
   1. 我：确实如此。这里说的「重新选择」，要比「立即放下所有的过去」容易得多，感觉变得可以操作了。就
      我的经历而言，我当前的人生都是我有意识主动选择的结果，我并不缺乏「获得幸福的勇气」，没有这样的
      烦恼。
8. 无论之前的人生发生过什么，都对今后的人生如何度过没有任何影响。
   1. 我：这又回到了「立即放下所有的过去」的问题，太过理想主义了，现实中几乎没有人能做到这一点。
9. 困扰我们的自卑感不是「客观性的事实」，而是「主观性的解释」。
   1. 不患寡而患不均，这句话说的就是这个道理。自卑源于与他人的比较产生的主观感受。（许多现代企业对此
      问题的解法是，禁止企业员工互相交流薪资情况...）
   1. 不要陷入纵向比较（指我与别人的高低、先后顺序），而应该学会与人缔结横向关系（即平等关系）。
10. 优越情结：表现得好像自己很优秀，继而沉静在一种虚假的优越感之中。
    1. 《山月记》中的名句说的就是这个：「因为害怕自己并非明珠而不敢刻苦琢磨，又因为有几分相信自己是
       明珠，而不甘与瓦砾碌碌为伍，遂逐渐远离世间，疏避人群，结果在内心不断地用愤懑和羞怒饲育着自己
       懦弱的自尊心。」
11. 人生不是一场比赛，没有先后顺序。人的价值在于不断超越自我。
12. 如果在人际关系中存在竞争，那人就不可能摆脱人际关系带来的烦恼，也就不可能摆脱不幸。
    1. 我还挺认同这一点的。我过去所有让我自豪的成就（我当前的工作、在开源社区收到的感谢、等等），都
       不是跟别人比来的，而是从我自己的兴趣爱好、内心的追求出发，自主选择的结果。如果跟人比，那清北
       的许多天才都能秒杀我，这么比的话我还有什么存在的必要？直接陷入虚无主义了。
13. 如果孩子出现不良行为，譬如逃学、摔东西、自残、甚至割腕、轻生，要注意到孩子真实的目的很可能是「报
    复使 TA 感到痛苦的人（通常是父母或老师）」，让对方也感受到痛苦。
14. 我们「并不是为了满足他人的期待而活着」，他人也「不是为了满足你的期待而活」。
    1. 我：所以我们应该放弃「或在他人的世界里」，也放弃对他人的人生妄加干涉。
15. 一切人际关系矛盾都起因于对别人的课题妄加干涉或者自己的课题被人妄加干涉。我们分清楚自己的课题与别
    人的课题，只应该负责自己的课题。
16. 通过「某种选择所带来的结果最终要由谁来承担？」这个问题，可以分清楚自己的课题与别人的课题。
17. 可以把马带到水边，但不能强迫它喝水。
    1. 马喝不喝水，是马的课题。
18. 自由就是被某些人讨厌，这是你行使自由以及活得自由的证据，也是你按自我方针生活的表现。
    1. 我：我得说确实如此。毕竟你如果不去主动迎合所有人，那被某些人讨厌就是必然的结果。
19. 毫不在意别人的评价、不害怕被人讨厌、不追求被他人认可，如果不付出以上代价，就无法贯彻自己的生活方
    式。
    1. 我：感觉第一点跟第三点我还做得挺好的，我一直比较有主见。但我一直很害怕被人讨厌。
20. 这个世界很大，你所面对的问题只不过是「杯中风暴」而已，只要跳出杯子，猛烈的风暴也会变成微风。
21. 活在害怕关系破裂的恐惧中，那是为他人而活的一种不自由的生活方式。
22. 没必要固执于当前的小共同体（小杯子），更多其他的「我和你」、更多其他的「大家」一定存在。
23. 批评不好，表扬也不行。因为这两种行为都是居高临下的评价，是「纵向关系」的产物。
24. 应该提倡基于横向关系（平等）的援助，也就是鼓励。比如说「谢谢」、「太感谢了」，这些都是平等的鼓
    励。
25. 人只有在感觉到自己有价值的时候，才可以获得勇气。
    1. 我：感同身受。19 年刚参加工作的时候我非常不自信，因为不知道自己价值几何。我是在工作中找到了自
       己的价值感，才获得了自信心。
26. 人只有在可以体会到「我对共同体有用」的时候，才能够感觉到自己的价值。
    1. 我：感同身受。我的价值感就来源于我在工作中获得的各种认可，让我理解到我对这个小共同体有用。
27. 在相信他人的时候不附加任何条件。
    1. 我：这太难了，也可能我还没理解整套哲学观，所以做不到。
28. 劳动（工作）并不仅仅是获得金钱的手段，人们也通过劳动来找到「我对他人有用」的价值感。
29. 将焦点聚焦到微不足道的一个方面并企图以此来评价整个世界，这就是缺乏人生和谐的错误生活方式。
    1. 我：我工作以来的三年多其实都一直更关注工作，业余大部分时间就是看网络小说。这种生活方式太单调
       了，我也是最近才意识到，工作只是人生的一方面而已，人生还有好多的可能性。
30. 做出不良行为的孩子，可能只是为了获得关注而「特立独行」，脱离「普通」状态，成为「特别」的存在，是
    一种「廉价的优越性追求」。
31. 不应该追求自身的优越性，要有甘于平凡的勇气。没有必要设定远大的目标，计划式的人生不是有没有必要，
    而是根本不可能。
32. 人生无常，它不是一根可以规划好的直线，而是一连串的刹那。人生像是一场旅行，只是为了到达目的地那不
    叫旅行，旅行是为了旅途中的风景，至于到没到目的地，这并不重要。
33. 每个人的世界都取决于 TA 对世界的主观理解，因此不能靠他人来改变，只能靠自己改变。
