## 如何模拟大量 TCP 连接

在对网关进行性能测试时，我们需要尽量逼近真实环境，以提升测试结果的可信度。

在真实环境中，许多客户端都会与网关建立大量 HTTP/1.1 的长连接，从实际流量观察上看这些连接绝大部分都是
不活跃的。虽然长连接不活跃，但它却实实在在地占用了网关的资源，对网关的性能有很大影响，因此为了模拟真
实环境，我们也需要模拟大量的 TCP 连接。

## 原理分析

首先回顾下 TCP 连接的四元组概念，每个连接都要求如下四元组唯一：「**src_ip, src_port, dst_ip,
dst_port**」。

以对单台网关服务器进行性能测试为例，通常我们只会对客户端开放 80 （HTTP）或者 443 （HTTPS）端口，那么
dst_ip 与 dst_port 就固定住了。

在使用单台打压机进行性能测试时，src_ip 也是固定的，因此唯一变化的就是 src_port，那只剩下 src_port 是
唯一变量，客户端通常只使用 4000 以上的端口，所以单台打压机能模拟的最大 TCP 连接数为 65535 - 4000 =
61535，有可能还有其他端口有特殊用途，不过实际可用端口数应该跟这个数差距不大。

所以为了模拟比如说十万的 TCP 连接，我们需要使用至少两台打压机。

## 如何实现

这个有很多种方法，locust/k6/wrk2 应该都行。

为了模拟线上大量 TCP 连接，但是 QPS 不高的场景，我们可以使用 wrk2，它可以模拟大量的 TCP 连接，但是
QPS 可以控制，而且使用也足够简单。
